Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.h	(revision 27014)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.h	(revision 27015)
@@ -159,4 +159,5 @@
     virtual void sltMousePointerShapeChanged();
     virtual void sltMouseCapabilityChanged();
+    virtual void sltPerformGuestResize(const QSize & /* toSize */) {};
 
     /* Session callback handlers: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp	(revision 27014)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp	(revision 27015)
@@ -54,4 +54,7 @@
     /* Cleanup machine window: */
     cleanupMachineWindow();
+
+    /* Cleanup action related stuff */
+    cleanupActionGroups();
 }
 
@@ -109,4 +112,15 @@
     }
 
+    /* Take the toggle hot key from the menu item. Since
+     * VBoxGlobal::extractKeyFromActionText gets exactly the
+     * linked key without the 'Host+' part we are adding it here. */
+    QString hotKey = QString ("Host+%1")
+        .arg (VBoxGlobal::extractKeyFromActionText(actionsPool()->action(UIActionIndex_Toggle_Fullscreen)->text()));
+    Assert (!hotKey.isEmpty());
+
+    /* Show the info message. */
+    if (!vboxProblem().confirmGoingFullscreen(hotKey))
+        return false;
+
     return true;
 }
@@ -161,4 +175,12 @@
     menu->clear();
     menu->addAction(actionsPool()->action(UIActionIndex_Toggle_MouseIntegration));
+}
+
+void UIMachineLogicFullscreen::prepareActionGroups()
+{
+    UIMachineLogic::prepareActionGroups();
+
+    /* Adjust window isn't allowed in fullscreen */
+    actionsPool()->action(UIActionIndex_Simple_AdjustWindow)->setEnabled(false);
 }
 
@@ -303,4 +325,10 @@
 }
 
+void UIMachineLogicFullscreen::cleanupActionGroups()
+{
+    /* Reenable adjust window */
+    actionsPool()->action(UIActionIndex_Simple_AdjustWindow)->setEnabled(true);
+}
+
 #ifdef Q_WS_MAC
 # ifdef QT_MAC_USE_COCOA
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.h	(revision 27014)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.h	(revision 27015)
@@ -55,4 +55,5 @@
 
     /* Prepare helpers: */
+    void prepareActionGroups();
     void prepareActionConnections();
     void prepareMachineWindows();
@@ -61,4 +62,5 @@
     void cleanupMachineWindow();
     void cleanupActionConnections() {}
+    void cleanupActionGroups();
 
 #ifdef Q_WS_MAC
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineViewFullscreen.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineViewFullscreen.cpp	(revision 27014)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineViewFullscreen.cpp	(revision 27015)
@@ -50,5 +50,5 @@
 #endif
                     , uMonitor)
-    , m_bIsGuestAutoresizeEnabled(pMachineWindow->machineLogic()->actionsPool()->action(UIActionIndex_Toggle_GuestAutoresize)->isChecked())
+, m_bIsGuestAutoresizeEnabled(pMachineWindow->machineLogic()->actionsPool()->action(UIActionIndex_Toggle_GuestAutoresize)->isChecked())
     , m_fShouldWeDoResize(false)
 {
@@ -189,6 +189,5 @@
         maybeRestrictMinimumSize();
 
-        if (uisession()->isGuestSupportsGraphics() && m_bIsGuestAutoresizeEnabled)
-            sltPerformGuestResize();
+        sltPerformGuestResize();
     }
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp	(revision 27014)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp	(revision 27015)
@@ -277,12 +277,7 @@
 }
 
-//#include "UIMachineViewFullscreen.h"
 void UIMachineWindowFullscreen::loadWindowSettings()
 {
-    /* Load normal window settings: */
-//    CMachine machine = session().GetMachine();
-
     /* Toggle console to manual resize mode. */
-//    m_pMachineView->setMachineWindowResizeIgnored(true);
     m_pMachineView->setFrameBufferResizeIgnored(true);
 
@@ -290,7 +285,7 @@
     QPalette palette(centralWidget()->palette());
     palette.setColor(centralWidget()->backgroundRole(), Qt::black);
-    centralWidget()->setPalette (palette);
-    centralWidget()->setAutoFillBackground (true);
-    setAutoFillBackground (true);
+    centralWidget()->setPalette(palette);
+    centralWidget()->setAutoFillBackground(true);
+    setAutoFillBackground(true);
 
     /* Here we are going really fullscreen */
@@ -301,23 +296,8 @@
     /* Make sure it is really on the right place (especially on the Mac) */
     move(0, 0);
-
-//    m_pMachineView->normalizeGeometry(true);
-//    ((UIMachineViewFullscreen*)m_pMachineView)->sltPerformGuestResize(maximumSize());
-
-//    QRect r = geometry();
-    /* Load global settings: */
-    {
-//        VBoxGlobalSettings settings = vboxGlobal().settings();
-//        menuBar()->setHidden(settings.isFeatureActive("noMenuBar"));
-    }
 }
 
 void UIMachineWindowFullscreen::saveWindowSettings()
 {
-//    CMachine machine = session().GetMachine();
-
-    /* Save extra-data settings: */
-    {
-    }
 }
 