Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp	(revision 27017)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp	(revision 27018)
@@ -53,7 +53,4 @@
     prepareMenu();
 
-    /* Prepare connections: */
-    prepareConnections();
-
     /* Retranslate normal window finally: */
     retranslateUi();
@@ -89,42 +86,7 @@
 }
 
-void UIMachineWindowFullscreen::sltMediumChange(const CMediumAttachment &attachment)
-{
-    KDeviceType type = attachment.GetType();
-    if (type == KDeviceType_HardDisk)
-        updateAppearanceOf(UIVisualElement_HDStuff);
-    if (type == KDeviceType_DVD)
-        updateAppearanceOf(UIVisualElement_CDStuff);
-    if (type == KDeviceType_Floppy)
-        updateAppearanceOf(UIVisualElement_FDStuff);
-}
-
-void UIMachineWindowFullscreen::sltUSBControllerChange()
-{
-    updateAppearanceOf(UIVisualElement_USBStuff);
-}
-
-void UIMachineWindowFullscreen::sltUSBDeviceStateChange()
-{
-    updateAppearanceOf(UIVisualElement_USBStuff);
-}
-
-void UIMachineWindowFullscreen::sltNetworkAdapterChange()
-{
-    updateAppearanceOf(UIVisualElement_NetworkStuff);
-}
-
-void UIMachineWindowFullscreen::sltSharedFolderChange()
-{
-    updateAppearanceOf(UIVisualElement_SharedFolderStuff);
-}
-
 void UIMachineWindowFullscreen::sltTryClose()
 {
     UIMachineWindow::sltTryClose();
-}
-
-void UIMachineWindowFullscreen::sltProcessGlobalSettingChange(const char * /* aPublicName */, const char * /* aName */)
-{
 }
 
@@ -140,47 +102,4 @@
 //    m_pDockEnablePreviewMonitor->setText(tr("Show Monitor Preview"));
 #endif /* Q_WS_MAC */
-}
-
-void UIMachineWindowFullscreen::updateAppearanceOf(int iElement)
-{
-    /* Update parent-class window: */
-    UIMachineWindow::updateAppearanceOf(iElement);
-}
-
-bool UIMachineWindowFullscreen::event(QEvent *pEvent)
-{
-    return QIWithRetranslateUI<QIMainDialog>::event(pEvent);
-    // TODO_NEW_CORE
-    switch (pEvent->type())
-    {
-        case QEvent::Resize:
-        {
-            QResizeEvent *pResizeEvent = static_cast<QResizeEvent*>(pEvent);
-            if (!isMaximized())
-            {
-                m_normalGeometry.setSize(pResizeEvent->size());
-#ifdef VBOX_WITH_DEBUGGER_GUI
-                // TODO: Update debugger window size!
-                //dbgAdjustRelativePos();
-#endif
-            }
-            break;
-        }
-        case QEvent::Move:
-        {
-            if (!isMaximized())
-            {
-                m_normalGeometry.moveTo(geometry().x(), geometry().y());
-#ifdef VBOX_WITH_DEBUGGER_GUI
-                // TODO: Update debugger window position!
-                //dbgAdjustRelativePos();
-#endif
-            }
-            break;
-        }
-        default:
-            break;
-    }
-    return QIWithRetranslateUI<QIMainDialog>::event(pEvent);
 }
 
@@ -212,30 +131,4 @@
 }
 
-void UIMachineWindowFullscreen::prepareConsoleConnections()
-{
-    /* Base-class connections: */
-    UIMachineWindow::prepareConsoleConnections();
-
-    /* Medium change updater: */
-    connect(machineLogic()->uisession(), SIGNAL(sigMediumChange(const CMediumAttachment &)),
-            this, SLOT(sltMediumChange(const CMediumAttachment &)));
-
-    /* USB controller change updater: */
-    connect(machineLogic()->uisession(), SIGNAL(sigUSBControllerChange()),
-            this, SLOT(sltUSBControllerChange()));
-
-    /* USB device state-change updater: */
-    connect(machineLogic()->uisession(), SIGNAL(sigUSBDeviceStateChange(const CUSBDevice &, bool, const CVirtualBoxErrorInfo &)),
-            this, SLOT(sltUSBDeviceStateChange()));
-
-    /* Network adapter change updater: */
-    connect(machineLogic()->uisession(), SIGNAL(sigNetworkAdapterChange(const CNetworkAdapter &)),
-            this, SLOT(sltNetworkAdapterChange()));
-
-    /* Shared folder change updater: */
-    connect(machineLogic()->uisession(), SIGNAL(sigSharedFolderChange()),
-            this, SLOT(sltSharedFolderChange()));
-}
-
 void UIMachineWindowFullscreen::prepareMenu()
 {
@@ -243,11 +136,4 @@
     /* Menubar is always hidden in fullscreen */
     menuBar()->hide();
-}
-
-void UIMachineWindowFullscreen::prepareConnections()
-{
-    /* Setup global settings change updater: */
-    connect(&vboxGlobal().settings(), SIGNAL(propertyChanged(const char *, const char *)),
-            this, SLOT(sltProcessGlobalSettingChange(const char *, const char *)));
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.h	(revision 27017)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.h	(revision 27018)
@@ -57,12 +57,4 @@
     /* Console callback handlers: */
     void sltMachineStateChanged();
-    void sltMediumChange(const CMediumAttachment &attachment);
-    void sltUSBControllerChange();
-    void sltUSBDeviceStateChange();
-    void sltNetworkAdapterChange();
-    void sltSharedFolderChange();
-
-    /* LED connections: */
-    void sltProcessGlobalSettingChange(const char *aPublicName, const char *aName);
 
     /* Close window reimplementation: */
@@ -74,9 +66,5 @@
     void retranslateUi();
 
-    /* Update routines: */
-    void updateAppearanceOf(int aElement);
-
     /* Event handlers: */
-    bool event(QEvent *pEvent);
 #ifdef Q_WS_X11
     bool x11Event(XEvent *pEvent);
@@ -85,7 +73,5 @@
 
     /* Prepare helpers: */
-    void prepareConsoleConnections();
     void prepareMenu();
-    void prepareConnections();
     void prepareMachineView();
     void loadWindowSettings();
@@ -94,5 +80,4 @@
     void saveWindowSettings();
     void cleanupMachineView();
-    //void cleanupConnections() {}
     //void cleanupMenu() {}
     //void cleanupConsoleConnections() {}